### Function

# FwupdPlugin Firmware roundtrip_from_filename

since: 2.1.1

#### Declaration [src]

    gboolean
    fu_firmware_roundtrip_from_filename (
      const gchar* builder_fn,
      const gchar* checksum_expected,
      guint64 flags,
      GError** error
    )

#### Description [src]

Roundtrip a firmware from builder XML filename to binary and back to XML.

Available since: 2.1.1

#### Parameters

`builder_fn`

  Type: `const gchar*`

  XML filename describing the firmware.

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`checksum_expected`

  Type: `const gchar*`

  Expected SHA1 hash of the built binary blob.

  The argument can be `NULL`.
  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`flags`

  Type: `guint64`

  `FuFirmwareBuilderFlags`, e.g. `FU_FIRMWARE_BUILDER_FLAG_NO_BINARY_COMPARE`.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` for success.